package pl.soppo.ucwizard.model 
{
	import org.robotlegs.mvcs.Actor;
	import pl.soppo.ucwizard.view.*;
	/**
	 * ...
	 * @author Maciej Reichwald
	 */
	public class FormViewModel extends Actor 
	{
		private var _currentForm:int = 0;
		
		private var _formViews:Array;
		
		private function initFormViews():void
		{
			_formViews = new Array(
				new StartFormView(),
				new GeneralFormView(),
				new CourseFormView(),
				new GraphicsFormView(),
				new TranslationsFormView(),
				new InstallerFormView(),
				new GenerateFormView(),
				new ProgressFormView()
			);
		}
		
		public function get currentForm():int 
		{
			return _currentForm;
		}
		
		public function set currentForm(value:int):void 
		{
			if( value >=0 && value < _formViews.length)
				_currentForm = value;
		}
		
		public function get formViews():Array 
		{
			if ( _formViews == null )
				initFormViews();
			
			return _formViews;
		}
		
	}

}