package pl.soppo.ucwizard.model.mediators 
{
	import flash.events.Event;
	import flash.events.IEventDispatcher;
	import flash.events.TimerEvent;
	import flash.utils.Timer;
	import mx.events.FlexEvent;
	import mx.managers.PopUpManager;
	import org.robotlegs.mvcs.Mediator;
	import pl.soppo.ucwizard.controler.events.GenerateApplicationEvent;
	import pl.soppo.ucwizard.controler.events.ProgressGenerationEvent;
	import pl.soppo.ucwizard.view.GenerationResultPopupView;
	import pl.soppo.ucwizard.view.ProgressFormView;
	
	/**
	 * ...
	 * @author Maciej Reichwald
	 */
	public class ProgressFormViewMediator extends Mediator 
	{
		[Inject]
		public var view:ProgressFormView;
		
		override public function onRegister():void
		{
			addContextListener(GenerateApplicationEvent.GENERATE_APP_RESULT, handleGenerationResult);
			addContextListener(ProgressGenerationEvent.GENERATION_PROGRESS, handleProgress);
			
			var timer:Timer = new Timer(50);
			timer.addEventListener(TimerEvent.TIMER, handleTimer);
			timer.start();
		}
		
		private function handleGenerationResult(e:GenerateApplicationEvent):void 
		{
			var popup:GenerationResultPopupView = new GenerationResultPopupView();
			PopUpManager.addPopUp(popup, view, true);
			PopUpManager.bringToFront(popup);
			PopUpManager.centerPopUp(popup);
			mediatorMap.createMediator(popup);
			
			popup.setUpView(
				"Generation Completed",
				e.result);
		}
		
		private function handleTimer(e:TimerEvent):void 
		{
			var timer:Timer = e.currentTarget as Timer;
			timer.stop();
			timer.removeEventListener(TimerEvent.TIMER, handleTimer);
			dispatch( new GenerateApplicationEvent(GenerateApplicationEvent.GENERATE_APP) );
		}
		
		private function handleAddedToStage(e:Event=null):void 
		{
			dispatch( new GenerateApplicationEvent(GenerateApplicationEvent.GENERATE_APP) );
		}
		
		private function handleProgress(e:ProgressGenerationEvent):void 
		{
			view.changeProgress(e.progress, e.label);
		}
		
	}

}